init:
    python:

        base_font_size = 32
        font_size_delta = 4
        
        def bullet(what,
                   bullet=None,
                   font_delta=0,
                   bullet_color=None,
                   text_color=None):

            size = base_font_size + font_size_delta * font_delta

            ui.hbox()
            ui.text(bullet, size=size, color=bullet_color)
            ui.text(what, size=size, color=text_color)
            ui.close()

        def text(what,
                 align=0,
                 font_delta=0,
                 text_color=None):

            size = base_font_size + font_size_delta * font_delta
            ui.text(what, size=size, color=text_color, xpos=align, xanchor=align, textalign=align)

        def show_image(what, align=0):
            ui.hbox(10, xpos=align, xanchor=align)

            for i in what.split(";"):
                i = i.strip()
                ui.image(i, xpos=align, xanchor=align)

            ui.close()

        def show_code(code):
            ui.window(style='default', xfill=True, background=Solid((16, 16, 16, 255)), xpadding=5, ypadding=5)
            ui.text(code, font="VeraMono.ttf", size=24)
            
        
        # The index of this slide.
        slide_index = 0

        # The title of the slide.
        slide_title = ""

        # The elements of the slide.
        elements = [ ]
        

        def element(func, **kwargs):
            def rv(*args):
                elements.append((func, args, kwargs))

            return rv

        def ss():

            ui.image("slideback.png")

            ui.window(style='default', xfill=True, yfill=True, top_padding=10, xpadding=20)
            ui.vbox(10)

            if slide_title:
                ui.window(style='default', xfill=True)
                ui.text(slide_title, xpos=0.5, xanchor=0.5, size=base_font_size + 8, font="VeraBd.ttf", color=(255, 255, 0, 255), textalign=0.5)

                ui.image("cyanbar.png", xpos=0.5, xanchor=0.5)
                ui.null()
            
            for func, args, kwargs in elements:
                func(*args, **kwargs)

            ui.close()

            ui.text("%d" % slide_index, size=18, xpos=1.0, ypos=1.0, xanchor=1.0, yanchor=1.0)

            ui.saybehavior()

            ui.interact()

            renpy.checkpoint()


        def title(what):
            store.slide_index += 1
            store.slide_title = what
            store.elements = [ ]

        c = element(text, align=0.5, text_color=(255, 255, 255, 255))

        b = element(bullet,
                    bullet=u"\u2022 ",
                    bullet_color=(255, 255, 255, 255), 
                    text_color=(255, 255, 255, 255),
                    )

        bb = element(bullet,
                     bullet=u"    \u2022 ",
                     bullet_color=(255, 255, 255, 255), 
                     text_color=(255, 255, 255, 255),
                     font_delta=-1,
                     )

        im = element(show_image, align=0.5)

        code = element(show_code)


init:
    $ m = Character("Mary")

    $ style.default.size = 28

    image bg sunrise = "dawn1.jpg"
    image mary happy = "mary_dawn_smiling.png"
    image bg night = "night.png"
    image mary wistful = "mary_wistful.png"

    $ library.enter_transition = pixellate
    $ library.exit_transition = pixellate
    

label main_menu:
    return

label start:

#    jump warp

    title "A Gentle Introduction to Making Visual Novels with Ren'Py"

    c ""
    c ""
    c "PyTom (American Bishoujo)"
    c ""
    c "Llamacon - February 25, 2006"
    c ""
    c "http://www.bishoujo.us/"

    $ ss()

    title "Goals of this Talk"

    b "To convince you to make visual novels."

    bb "What are visual novels?"

    # bb "Where can you get them?"

    bb "How do you make them?"

    b "To teach you how to use Ren'Py to make your first VN."

    $ ss()

    title "About the Presenter"

    b "Sole Member of American Bishoujo."

    b "Maker of tools that help create VNs."

    bb "Ren'Py - Visual Novel Engine"

    bb "ALICE - Character Art Maker"

    b "Creator of Moonlight Walks."

    b "Co-maintainer of the Ren'Ai Archives."

    # b "Not really an artist or writer."

    $ ss()

    title "What are Visual Novels?"

    b "A visual novel is a computer program that tells a story by
    presenting a series of pictures, words, and choices to user."

    bb "They tend to present stories from a first-person POV."

    bb "These stories tend to be foremost about relationships between
        characters."

    b "Easiest to demonstrate with an excerpt..."

    $ ss()


    show bg sunrise

    "I realized that throughout the entire night, I had never
     asked her what her name was."

    "So I asked her, almost shouting the question to her."

    show mary happy with dissolve
    
    "She stopped walking, turned back to me, and smiled."

    m "It's Mary... Mary Harper!"


    title "Why Visual Novels?"

    b "Compared to prose, VNs are..."

    bb "Visual. People like having pictures with their stories."

    b "Compared to comics/manga, VNs are..."

    bb "First-Person. VNs are a visual medium that places you in the story."

    b "Compared to everything else, VNs are..."

    bb "Interactive. Computers let you change the story in response to user input."

    $ ss()

    title "Some Terminology"

    b "Kinetic Novel"

    bb "A visual novel without any choices."

    b "Ren'Ai Game"

    bb "A game (not necessarily a VN) in which romance is a major component."

    $ ss()

    title "English-Language Visual Novels"

    b "English-Language VNs come from 4 sources:"

    bb "Commercial Translations (J-List, Hirameki)."
    
    bb "Fan-Translated Demos (Many)/Games (Planetarian)."

    bb "Fan-Translated Doujin-Games (Al|together 2005)." 
    
    bb "Original English-Language Games."

    $ ss()

#     title "Commercially Translated Games"

#     b "J-List Zaibatsu"

#     bb "Adult/Hentai Games"

#     bb "Kana, Crescendo, Private Nurse, ..."

#     b "Hirameki International"

#     bb "PG Games"

#     bb "Ever 17, Hourglass of Summer, ..."

#     im "sc03.jpg"

#     $ ss()

#     title "Fan-Translated Games"

#     b "Translations of Full Commercial Games"

#     bb "Planetarian, others not done."

#     b "Translation of Commercial Game Demos"

#     bb "7 by {u}Insani{/u}."

#     b "Translation of Doujin-Games"

#     bb "Al|together 2005 - 10 games translated, most kinetic novels."

#     b "The hub of this community seems to be the {u}Haeleth Forums{/u}."

#     $ ss()

    title "Original English-Language Games"

    b "The OELVN Community is rapidly growing:"

    bb "1 game each in 2002, 2003."
    bb "4 games in 2004."
    bb "17 games in 2005. (First NaNoRenO)"
    bb "2 games in 2006 (to date)."

    b "Discussion at the {u}Lemma Soft Forums{/u}."

    b "Many free games available from the {u}Ren'Ai Archives{/u}."

    $ ss()

    title "OELVN Pictures"

    im "gsk-2.png; ruleworld-2.png"
    im "heikou-1.png; tteacher-1.png"

    c "The Garden Society: Kykuit; When I Rule the World; Heikou; Transfer Teacher"

    $ ss()

    title "NaNoRenO"

    b "NaNoRenO is a challenge in which people try to make a complete game in a month."

    bb "(based on NaNoWriMo)"

    b "In 2005, 6 games were made in that month."

    b "NaNoRenO 2006 runs from March 1st to March 31st, 2006."

    bb "It's not too late to join!"

    $ ss()

    title "Making Your Own Visual Novels"

    b "The most important thing you need is a story to tell."

    bb 'A story you "Can\'t not tell".'

    bb "Stories that are told from a first-person perspective work the
        best." 

    b "For your first game, keep it simple."

    bb "1-2 characters (not counting POV), short timeframe."

    bb "Games with many characters or long timeframes tend not to be completed."

    $ ss()
    
    title "Tasks in Making a Game"

    b "Script"

    b "Character Art"

    b "Background Art"

    b "Music"

    b "Game Engine"

    b "Integration"

    $ ss()

    title "Accomplishing These Tasks"

    b "A writer is necessary, and he's usually the leader/integrator."

    bb "We've yet to see a non-writer-lead team complete a game."

    b "Character art really helps."

    bb "Note to artists: Be sure you work with a reliable writer."

    b "Background art can be drawn, or filtered photographs."

    b "Music can be creative-commons, or randomly-generated, etc."

    $ ss()

    title "Where Ren'Py Fits In"

    b "To accomplish those tasks, one needs a writer, artists, and programmer."

    bb "While some writer/artist/programmers exist, they're rare."

    b "Ren'Py is a free engine you can use in your game."

    bb "It lets you eliminate the programmer, needing only a writer/artist."

    bb "These skills are often found together--- see comics/manga."

    $ ss()

    title "About Ren'Py"

    b "Ren'Py is a programming language and engine for creating Visual
       Novels."

    b "It's based on the executable scripting concept."

    bb "Typing in the script leads to a playable game."

    bb "Script remains readable throughout the process."
    
    $ ss()

    title "Who uses Ren'Py?"

    b "Ren'Py is the most popular engine in the OEL community."

    bb "11 of 17 games in 2005, 2 of 2 in 2006"

    b "It can be used by programmers and non-programmers."

    bb "Can be learned by remembering patterns, if necessary."

    b "It can be used by experienced and inexperienced creators."

    bb "Many features for customization, few are necessary for a basic
        game."

    $ ss()


    title "Getting Started"

    b "You'll want to download Ren'Py from the {u}Ren'Py Home Page{/u}, and unpack it."

    b "You need to edit the file script.rpy in the game directory, and then run run_game.exe."

    b "More details about getting started are in the {u}Ren'Py Tutorial{/u}."


    title "Sample Script"

    code r'
label start:

scene bg night  

"It was the summer before I started college."
"I decided to take the opportunity to explore."

show mary wistful

"I met a girl, and asked what she was doing."
m "Walking."
  
init:
  $ m = Character("Mary")
  image bg night = "night.png"
  image mary wistful = "mary_wistful.png"'  

    $ ss()

    scene bg night  

    "It was the summer before I started college."
    "I decided to take the opportunity to explore."

    show mary wistful

    "I met a girl, and asked what she was doing."    

    m "Walking."
    

    #~ title "Blocks"

    #~ code r'
#~ init:
  #~ $ m = Character("Mary")
  #~ image bg night = "night.png"
  #~ image mary wistful = "mary_wistful.png"

#~ label start:
  #~ scene bg night  

  #~ "It was the summer before I started college."
  #~ "I decided to take the opportunity to explore."'

    #~ b "A block is a group of lines that start with the same indentation."

    #~ bb "Indentation matters in Ren'Py."
   

    #~ $ ss()

    title "Start Label and Thoughts"

    code r'
label start:

"It was the summer before I started college."'

    b "The start label is the place where your game begins running."

    b "A string (in quotes) by itself is displayed to the user as a thought."

    $ ss()

    scene black

    "It was the summer before I started college."

    title "Init Blocks and Characters"

    code r'
init:
  $ m = Character("Mary")'

    b "Init blocks are used to run things when Ren'Py first starts."

    bb "Lines in blocks must be indented the same."
    
    bb "Indentation matters in Ren'Py."

    b "In this case, there's one statement, which is used to create a Character."

    bb "The character will used the name \"Mary\"."

    bb "The character is given the short name \"m\"."

    $ ss()

    title "Dialogue"

    code r'
m "My sisters and I... we were the best of friends."

m "We almost had to be, since our house was so
   small."'

    b "A line consisting of a short name followed by a string is a
       line of dialogue."

    b "These are used when a character speaks."

    $ ss()
    
    m "My sisters and I... we were the best of friends."

    m "We almost had to be, since our house was so small."


    title "Declaring Images"

    code r'
init:
  image bg sunrise = "sunrise.png"
  image mary happy = "mary_happy.png"
  image mary sad = "mary_sad.png"'

    b "The image statement declares images."

    b "Each image has a name consisting of one or more words."

    bb "The first word is the \"tag\" of the image."

    b "Each image points to an image file."

    $ ss()

    title "Showing Images"

    code r'
scene bg sunrise
show mary happy

m "..."'

    b "The scene statement clears the screen, and shows the named image."

    b "The show statement shows the named image on the screen."

    bb "If an image with the same tag is already shown, it is replaced."

    b "The hide statement hides an image, but it's rarely used."

    $ ss()

    scene bg sunrise
    show mary happy

    m "..."

    title "Showing Images At"

    code r'
show mary happy at right'

    b "The show and scene statements also take an at clause, that says where the image will be displayed."

    bb "Common choices: left, right, center"

    $ ss()

    show mary happy at right

    m "..."

    title "Kinetic Novels vs Visual Novels"

    b "These features are all you need to make a simple kinetic
       novel."

    b "For a full visual novel, one needs to be able to branch on
       choices."

    bb "Control-based--- immediately branches and never recombines."

    bb "Variable-based--- stores data in variables, branches later."

    $ ss()

    title "Jumping to a Label"

    code r'
jump ask_name
       
label ask_name:
...'

    b "We can have many labels, not just start."

    bb "Labels can be followed by a block, but don't have to be."

    b "The jump statement jumps to the label with the given name."

    $ ss()

    title "Menus"

    code r'
menu:
  "I asked her..."
  "... what her name was.":
    jump ask_name
  "... when I could see her again.":
    jump ask_when'

    b "A menu lets the user make a choice."

    b "A string by itself in the menu block is a label."

    b "A string followed by a colon is a choice."

    bb "If picked, the code in the block following the choice runs."

    $ ss()

    show mary happy at center

menu:
  "I asked her..."
  "... what her name was.":
    jump ask_name
  "... when I could see her again.":
    jump ask_when

label ask_name:
label ask_when:

    title "Variables and Python"

    code r'
$ have_swimsuit = True
$ have_parka = False
if have_swimsuit:
   jump visit_pool

$ points = 0
$ points = points + 1
if points > 5:
    jump good_ending
else:
    jump bad_ending'

    $ ss()

    title "Python"

    b "Ren'Py supports Python statements, just prefix them with \"$\"."

    b "Ren'Py supports an if statement, which takes a Python expression."

    b "These let you set flags that you can use later in your program."

    bb "A flag must be set before it is used!"

    b "Python is used to access other features:"

    code '$ renpy.music.play("ending.ogg")'
    
    $ ss()

    title "Transitions"

    code r'
with None
show mary happy
with dissolve'

    b "Transitions are from the last thing shown to the current
       scene."

    bb "'with None' sets the last shown to the current."

    bb "'with <transition>' performs a transition."

    b "Ren'Py supports dozens of transitions."

    bb "Dissolve is perhaps the most useful."

    code 'show mary happy with dissolve'

    bb "Equivalent to above code."

    $ ss()

    with pixellate

    $ renpy.pause(1)

    hide mary with dissolve

    $ renpy.pause(1)

    show mary happy with dissolve

    $ renpy.pause(1)
    
    $ renpy.transition(pixellate)

    title "More Features"

    b "Ren'Py can play music, sound effects, and movies."

    b "Styles let you customize the look of your game."

    b "Ren'Py gives you many expected features:"

    bb "Rollback, Load/Save, Text Speed, Auto-Forward Mode, and more!"

    $ ss()

    title "Getting Help"

    b "The first place to go for help is the {u}Ren'Py Tutorial{/u}."

    b "After that, ask for help on the {u}Lemma Soft Forums{/u}."

    bb "I'll usually answer in a short while, and many others will also try to help."

    $ ss()

    title "In Closing..."

    b "{b}You{/b} can make visual novels..."

    bb "... and I want to see what you make!"

    b "http://www.bishoujo.us/ has links to all the sites I mention."

    b "Any questions?"

label end:

    $ ss()
    
    jump end
                                            

# 2002
# 1 RAA

# 2003
# 1 RAA

# 2004
# 4 RAA

# 2005
# 13 RAA (8) 
# 1 Sango (1)
# 2 Dreamers (2)
# 1 Summer Schoolgirls

# 2006
# 1 RAA (1)
# 1 Dreamers 1

